#include "tempdialog.h"
#include "ui_tempdialog.h"

#define TEMP_RATIO (3.3/1024/0.0195)  //3.3V is the PS, 1024 is resolution of ADC, 0,0195 V/C resolution of MCP9701
#define TEMP_OFFSET (0.4/3.3 *1024) //0.4V = 0C

TempDialog::TempDialog(SR_HANDLE s, QWidget *parent) : QDialog(parent), ui(new Ui::TempDialog)
  {
  srh = s;
  ui->setupUi(this);
  timer = new QTimer(this);
  timer->setInterval(1000);
  timer->start();

  connect(timer, SIGNAL(timeout()), this, SLOT(timerUpdate()));
  connect(ui->exitButton, SIGNAL(clicked()), this, SLOT(close()));
  setupDevice();
  timerUpdate();
  }

TempDialog::~TempDialog()
  {
  delete ui;
  sr_close(srh);
  }

void TempDialog::setupDevice()
  {
  sr_pin_setup(srh, 6, sr_pt_analog_in);
  sr_pin_setup(srh, 7, sr_pt_analog_in);
  }

void TempDialog::timerUpdate()
  {
  unsigned short t;
  sr_pin_get_analog(srh, 6, &t);
  ui->labelT1->setText(QString::number((t-TEMP_OFFSET)*TEMP_RATIO, 'f', 1) + " C");
  sr_pin_get_analog(srh, 7, &t);
  ui->labelT2->setText(QString::number((t-TEMP_OFFSET)*TEMP_RATIO, 'f', 1) + " C");
  }
